unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls, Math, CPort;

type
  TForm1 = class(TForm)
    Edit1  : TEdit;
    Panel1 : TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label17: TLabel;
    ComPort1: TComPort;
    CheckBox1: TCheckBox;
    procedure Edit1KeyPress  (Sender : TObject; var Key : Char);
    procedure FormCreate     (Sender : TObject);
    procedure ComPort1RxChar (Sender : TObject; Count : Integer);
    procedure FormClose      (Sender : TObject; var Action : TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
  private
  public
    procedure RePaintCircle;
  end;

var
  Form1 : TForm1;
  Angle : Integer;
  UARTBuff : string;

implementation

{$R *.dfm}

procedure TForm1.RePaintCircle;
const
  Pi = 3.1415926535897932385;
  dAng = Pi / 180;
var
  i : WORD;
  Ang1, Ang2 : WORD;
  Ua, Ub, Uc : WORD;

  ResetAngl : WORD;

  wResetAngl : WORD;

  dUaUb : Real;
  dUbUc : Real;
  dUcUa : Real;
  dUaUc : Real;
  dUcUb : Real;
  dUbUa : Real;

  dwUaUb : DWORD;
  dwUbUc : DWORD;
  dwUcUa : DWORD;
  dwUaUc : DWORD;
  dwUcUb : DWORD;
  dwUbUa : DWORD;

  s : String;

  fWite : Boolean;

begin
  Image1.Canvas.Brush.Color := clBtnFace;

  Image1.Canvas.Pen.Color := RGB (0, 0, 255);
  Image1.Canvas.Ellipse (10, 10, 301, 301);
  Image1.Canvas.MoveTo (155, 155);
  Image1.Canvas.LineTo (297, 155);
  Image1.Canvas.MoveTo (155, 155);
  Image1.Canvas.LineTo (155 + Round (Sin (dAng * 90 + dAng * 120) * 143), 155 + Round (Cos (dAng * 90 + dAng * 120) * 143));
  Image1.Canvas.MoveTo (155, 155);
  Image1.Canvas.LineTo (155 + Round (Sin (dAng * 90 + dAng * 240) * 143), 155 + Round (Cos (dAng * 90 + dAng * 240) * 143));

  Image1.Canvas.Pen.Color := RGB (0, 100, 0);
  Image1.Canvas.MoveTo (155 - Round (Sin (dAng * 90 + dAng * Angle) * 143), 155 - Round (Cos (dAng * 90 + dAng * Angle) * 143));
  Image1.Canvas.LineTo (155 + Round (Sin (dAng * 90 + dAng * Angle) * 143), 155 + Round (Cos (dAng * 90 + dAng * Angle) * 143));
  for i := 0 to 180 * 10 do
   begin
     Image1.Canvas.Pixels [155 + Round (Sin (dAng * 90 + dAng * (Angle - i / 10)) * 143), 155 + Round (Cos (dAng * 90 + dAng * (Angle - i / 10)) * 143)] := Image1.Canvas.Pen.Color;
   end;

  Edit1.Text := ' ' + IntToStr (Angle) + ' ';

  if (Angle > 0) and (Angle < 120) then
   begin
     Ua := 5000 + Abs (Round (2500 * (Angle / 60)));//  + 500;
   end else
   begin
     if (Angle > 119) and (Angle < 181) then
      begin
        Ua := 10000//  + 500;
      end else
      begin
        if (Angle > 180) and (Angle < 300) then
         begin
           Ua := 10000 - Abs (Round (2500 * ((Angle - 180) / 60)));//  + 500;
         end else
         begin
           Ua := 5000;//  + 500;
         end;
      end;
   end;

  if (Angle > 120) and (Angle < 241) then
   begin
     Ub := 5000 + Abs (Round (2500 * ((Angle - 120) / 60)));
   end else
   begin
     if (Angle > 240) and (Angle < 301) then
      begin
        Ub := 10000;
      end else
      begin
        if (Angle > 300) and (Angle < 360) then
         begin
           Ub := 10000 - Abs (Round (2500 * ((Angle - 120 - 180) / 60)));
         end else
         begin
           if (Angle > -1) and (Angle < 60) then
            begin
              Ub := 7500 - Abs (Round (2500 * (Angle / 60)));
            end else
            begin
              Ub := 5000;
            end;
         end;
      end;
   end;

  if (Angle > 60) and (Angle < 180) then
   begin
     Uc := 10000 - Abs (Round (2500 * ((Angle - 60) / 60)));
   end else
   begin
     if (Angle > -1) and (Angle < 61) then
      begin
        Uc := 10000;
      end else
      begin
        if (Angle > 179) and (Angle < 240) then
         begin
           Uc := 5000;
         end else
         begin
           Uc := 5000 + Abs (Round (2500 * ((Angle - 240) / 60)));
         end;
      end;
   end;

  Label1.Caption := '   A = ' + IntToStr (Ua);
  Label2.Caption := '   B = ' + IntToStr (Ub);
  Label3.Caption := '   C = ' + IntToStr (Uc);

  //       
  ResetAngl := 1000;
  fWite := TRUE;

  if (fWite) and (Uc > Ua) and (Uc > Ub) and ((Ub - Ua) * 2 <= Uc - Ua) and ((Ua - Ub) * 2 < Uc - Ub) then       // C  (0 - 60 )
   begin
     fWite := FALSE;
     ResetAngl := 300 - ((Ub - Ua) * 1200) div Uc;
     Label17.Caption := '1';
   end;
  if (fWite) and (Ub < Uc) and (Ub < Ua) and (Uc - Ub <= (Ua - Ub) * 2) and ((Uc - Ub) * 2 > Ua - Ub) then        // B  (60 - 120 )
   begin
     fWite := FALSE;
     ResetAngl := 900 - ((Uc - Ua) * 600) div Ub;
     Label17.Caption := '2';
   end;
  if (fWite) and (Ua > Ub) and (Ua > Uc) and ((Uc - Ub) * 2 <= Ua - Ub) and ((Ub - Uc) * 2 < Ua - Uc) then        // A  (120 - 180 )
   begin
     fWite := FALSE;
     ResetAngl := 1500 - ((Uc - Ub) * 1200) div Ua;
     Label17.Caption := '3';
   end;
  if (fWite) and (Uc < Ua) and (Uc < Ub) and (Ua - Uc <= (Ub - Uc) * 2) and (Ub - Uc < (Ua - Uc) * 2) then        // C 
   begin
     fWite := FALSE;
     ResetAngl := 2100 - ((Ua - Ub) * 600) div Uc;
     Label17.Caption := '4';
   end;
  if (fWite) and (Ub > Ua) and (Ub > Uc) and ((Ua - Uc) * 2 <= Ub - Uc) and ((Uc - Ua) * 2 < Ub - Ua) then        // B 
   begin
     fWite := FALSE;
     ResetAngl := 2700 - ((Ua - Uc) * 1200) div Ub;
     Label17.Caption := '5';
   end;
  if (fWite) and (Ua < Ub) and (Ua < Uc) and (Ub - Ua <= (Uc - Ua) * 2) and (Uc - Ua < (Ub - Ua) * 2) then        // A 
   begin
     fWite := FALSE;
     ResetAngl := 3300 - ((Ub - Uc) * 600) div Ua;
     Label17.Caption := '6';
   end;

  Label10.Caption := '  ' + IntToStr (Round (ResetAngl / 10)) + ' ';

end;

procedure TForm1.Edit1KeyPress (Sender : TObject; var Key : Char);
begin
  if Key = '-' then
   begin
     Angle := Angle - 1;
     if Angle < 0 then
      begin
        Angle := 359;
      end;
   end;
  if (Key = '+') or (Key = '=') then
   begin
     Angle := Angle + 1;
     if Angle > 359 then
      begin
        Angle := 0;
      end;
   end;
  RePaintCircle;
  Key := Chr (0);
end;

procedure TForm1.FormCreate (Sender : TObject);
begin
  RePaintCircle;
end;

procedure TForm1.ComPort1RxChar (Sender : TObject; Count : Integer);
var
  s : string;
  w : WORD;
begin
  ComPort1.ReadStr (s, Count);
  UARTBuff := UARTBuff + s;
  if Length (UARTBuff) > 1 then
   begin
     if ((Ord (UARTBuff [1]) and 128) > 0) and ((Ord (UARTBuff [2]) and 128) = 0) then
      begin
        w := (((Ord (UARTBuff [1]) and (255 - 128)) shr 1) * 256) + ((Ord (UARTBuff [1]) and 1) shl 7) + (Ord (UARTBuff [2]) and (255 - 128));
        if CheckBox1.Checked then
         begin
           Angle := w;
           RePaintCircle;
         end;
      end;
     UARTBuff := '';
   end;
end;

procedure TForm1.FormClose (Sender : TObject; var Action : TCloseAction);
begin
  ComPort1.Close;
end;

procedure TForm1.CheckBox1Click (Sender : TObject);
begin
  if CheckBox1.Checked then
   begin
     ComPort1.Open;
   end else
   begin
     ComPort1.Close;
   end;
end;

end.
